# coding: utf-8

"""
    Onshape REST API

    The Onshape REST API consumed by all clients.  # noqa: E501

    The version of the OpenAPI document: 1.111
    Contact: api-support@onshape.zendesk.com
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import
import re  # noqa: F401
import sys  # noqa: F401

import six  # noqa: F401

from onshape_client.oas.model_utils import (  # noqa: F401
    ModelComposed,
    ModelNormal,
    ModelSimple,
    date,
    datetime,
    file_type,
    int,
    none_type,
    str,
    validate_get_composed_info,
)


class BTAclEntryInfo(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('entry_state',): {
            'DELETED': "DELETED",
            'ACTIVE': "ACTIVE",
            'INACTIVE': "INACTIVE",
            'REQUESTED': "REQUESTED",
            'APPROVED': "APPROVED",
            'REQUEST_EXPIRED': "REQUEST_EXPIRED",
            'ALL': "ALL",
            'MARKED_FOR_DELETION': "MARKED_FOR_DELETION",
        },
    }

    validations = {
    }

    additional_properties_type = None

    @staticmethod
    def openapi_types():
        """
        This must be a class method so a model may have properties that are
        of type self, this ensures that we don't create a cyclic import

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'accept_owner_transfer': (bool,),  # noqa: E501
            'company_name': (str,),  # noqa: E501
            'email': (str,),  # noqa: E501
            'enterprise_member': (bool,),  # noqa: E501
            'entry_id': (str,),  # noqa: E501
            'entry_state': (str,),  # noqa: E501
            'entry_type': (int,),  # noqa: E501
            'image': (str,),  # noqa: E501
            'name': (str,),  # noqa: E501
            'object_id': (str,),  # noqa: E501
            'pending_owner_transfer': (bool,),  # noqa: E501
            'permission': (int,),  # noqa: E501
            'permission_set': (bool, date, datetime, dict, float, int, list, str,),  # noqa: E501
            'team_name': (str,),  # noqa: E501
        }

    @staticmethod
    def discriminator():
        return None

    attribute_map = {
        'accept_owner_transfer': 'acceptOwnerTransfer',  # noqa: E501
        'company_name': 'companyName',  # noqa: E501
        'email': 'email',  # noqa: E501
        'enterprise_member': 'enterpriseMember',  # noqa: E501
        'entry_id': 'entryId',  # noqa: E501
        'entry_state': 'entryState',  # noqa: E501
        'entry_type': 'entryType',  # noqa: E501
        'image': 'image',  # noqa: E501
        'name': 'name',  # noqa: E501
        'object_id': 'objectId',  # noqa: E501
        'pending_owner_transfer': 'pendingOwnerTransfer',  # noqa: E501
        'permission': 'permission',  # noqa: E501
        'permission_set': 'permissionSet',  # noqa: E501
        'team_name': 'teamName',  # noqa: E501
    }

    @staticmethod
    def _composed_schemas():
        return None

    required_properties = set([
        '_data_store',
        '_check_type',
        '_from_server',
        '_path_to_item',
        '_configuration',
    ])

    def __init__(self, _check_type=True, _from_server=False, _path_to_item=(), _configuration=None, **kwargs):  # noqa: E501
        """bt_acl_entry_info.BTAclEntryInfo - a model defined in OpenAPI


        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _from_server (bool): True if the data is from the server
                                False if the data is from the client (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            accept_owner_transfer (bool): [optional]  # noqa: E501
            company_name (str): [optional]  # noqa: E501
            email (str): [optional]  # noqa: E501
            enterprise_member (bool): [optional]  # noqa: E501
            entry_id (str): [optional]  # noqa: E501
            entry_state (str): [optional]  # noqa: E501
            entry_type (int): [optional]  # noqa: E501
            image (str): [optional]  # noqa: E501
            name (str): [optional]  # noqa: E501
            object_id (str): [optional]  # noqa: E501
            pending_owner_transfer (bool): [optional]  # noqa: E501
            permission (int): [optional]  # noqa: E501
            permission_set (bool, date, datetime, dict, float, int, list, str): [optional]  # noqa: E501
            team_name (str): [optional]  # noqa: E501
        """

        self._data_store = {}
        self._check_type = _check_type
        self._from_server = _from_server
        self._path_to_item = _path_to_item
        self._configuration = _configuration

        for var_name, var_value in six.iteritems(kwargs):
            setattr(self, var_name, var_value)
